\ 430eforth-g2553-43n7vis : gpio --> gpio-2207.fs                     MM-210320
\ ------------------------------------------------------------------------------
\ MIT License (C) 2022 430eForth Workbench Project

\ GPIO Register access for the MSP430G2553 MCU
\
\ Required: * MSP430G2553 MCU with 430eForth43n7vis
\           * e4thcom terminal 0.8.x or later
\                     options: -t 430eforth-xas -p xas:target:lib

\ Used:
\ 2CONSTANT
\ reg8 words
\ !  @  bi@  bix  bic  bis  u/i 

\ Provided:
\ forth words
\ P1  P2   \ The GPIO Ports that give access to the GPIO Registers.
\ gpio words
\ SEL2  REN  SEL  DIR  OUT  IN   \ The GPIO Port Registers
\ pin:                           \ Port Pin defining word

\ ------------------------------------------------------------------------------

-g2553-  \ MSP430G2553 only

#require reg8
#require 2constant

forth definitions

voc gpio  gpio definitions

\ The data structure for the GPIO Ports P1 and P2 :
\ All fields are reg8 data items/objects that give access to the reg8 words.
$00 reg8 field: IN  ( a0 -- a1 , C: reg8 )
    reg8 field: OUT
    reg8 field: DIR
    reg8 u/i +       \ reg8 field: IFG
    reg8 u/i +       \ reg8 field: IES
    reg8 u/i +       \ reg8 field: IE
    reg8 field: SEL
    reg8 field: REN
drop
    reg8 item : SEL2 ( a0 -- a1 , C: reg8 )
                dup $20 = if $21 + exit then
                dup $28 = if $1A + exit then
                -1 abort"  SEL2 ?"
              ;
{ 
\ Address of the ports interrupt vektor. Read with @ , write (once) with i!.
: IV ( a0 -- aIV  )
  dup $20 = if drop $FFE4 exit then
      $28 = if $FFE6 exit then abort"  IV?"
;
}

\ Create a port pin identifier.
: pin: ( "name" mask a.Px -- )  \ name ( -- mask a.Px , C: gpio )
  item 2constant
;

forth definitions

\ Data structure pointer for the GPIO Ports :
$20 gpio item constant P1 ( -- a0.P1 , C: gpio )
$28 gpio item constant P2 ( -- a0.P2 , C: gpio )


\ Last revision: MM-220702  port: removed, IV added
\                           uncomment I-words if required

\ Application hints:
\\

\ 0 mask P1 pin: P1.0   
  0 mask constant BIT0   BIT0 P1 pin: P1.0

\ P1.0 as digital output :
  P1.0 OUT  bic   \ output low
  P1.0 DIR  bis   \ output mode on
  P1.0 SEL  bic   \ GPIO mode on
  P1.0 SEL2 bic   \


  P1.0 OUT bis  \ Set P1.0 GPO

  3 mask constant BIT3

\ BIT3 P1 item 2constant P1.3 ( -- mask P1 , C: gpio )
  BIT3 P1 pin: P1.3 ( -- mask P1 , C: gpio )

\ P1.3 as digital input :
  BIT3 dup P1 REN  bic  \ no UP/DN resistor
       dup P1 DIR  bic  \ input mode on
       dup P1 SEL  bic  \ GPIO mode on
           P1 SEL2 bic  \

  BIT3 P1 IN bi@ ( -- 0|1 ) \ Read P1.3 GPI
     P1.3 IN bi@ ( -- 0|1 )

forth definitions decimal

\ EOF

